/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import common.CommonVariables;
import communication.ReadWrite;
import connection.BlueClient;
import connection.BlueServer;
import java.io.IOException;
import javax.bluetooth.LocalDevice;
import javax.microedition.io.Connector;
import javax.microedition.io.PushRegistry;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.wireless.messaging.MessageConnection;
import javax.wireless.messaging.Message;
import javax.wireless.messaging.TextMessage;

/**
 * @author sumanta
 */
public class BlueMIDlet extends MIDlet implements CommandListener {

    private boolean midletPaused = false;
    private Displayable gameCanvas;
    private Command exitCommand3;
    private Command newCommand;
    int incomingPort = 50000;
    MessageConnection incomingConnection = null;
    Message incomingMessage;

    //<editor-fold defaultstate="collapsed" desc=" Generated Fields ">//GEN-BEGIN:|fields|0|
    private List lstRole;
    private Form frmWaiting;
    private StringItem stringItem;
    private TextBox txtConnection;
    private Form menuForm;
    private StringItem welcomeString;
    private ImageItem nameImage;
    private Alert turnAlert;
    private TextBox instructionText;
    private TextBox aboutText;
    private Command cancelCommand;
    private Command exitCommand1;
    private Command exitCommand;
    private Command gameCommand;
    private Command exitCommand2;
    private Command sendCommand;
    private Command exitCommand4;
    private Command aboutCommand;
    private Command newCommand1;
    private Command instructionCommand;
    private Command okCommand1;
    private Command okCommand;
    private Ticker ticker;
    private Image image;
    //</editor-fold>//GEN-END:|fields|0|
    /**
     * The BlueMIDlet constructor.
     * 
     */
    public BlueMIDlet() {

    }

    //<editor-fold defaultstate="collapsed" desc=" Generated Methods ">//GEN-BEGIN:|methods|0|
    //</editor-fold>//GEN-END:|methods|0|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: initialize ">//GEN-BEGIN:|0-initialize|0|0-preInitialize
    /**
     * Initilizes the application.
     * It is called only once when the MIDlet is started. The method is called before the <code>startMIDlet</code> method.
     */
    private void initialize() {//GEN-END:|0-initialize|0|0-preInitialize
    String version = LocalDevice.getProperty("bluetooth.api.version");
    if(version == null)
        switchDisplayable(new Alert("Error!", "Your device does not support bluetooth API", 
                null, AlertType.ERROR), getDisplay().getCurrent());
//GEN-LINE:|0-initialize|1|0-postInitialize
    // write post-initialize user code here
    }//GEN-BEGIN:|0-initialize|2|
    //</editor-fold>//GEN-END:|0-initialize|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: startMIDlet ">//GEN-BEGIN:|3-startMIDlet|0|3-preAction
    /**
     * Performs an action assigned to the Mobile Device - MIDlet Started point.
     */
    public void startMIDlet() {//GEN-END:|3-startMIDlet|0|3-preAction
        // write pre-action user code here
        switchDisplayable(null, getMenuForm());//GEN-LINE:|3-startMIDlet|1|3-postAction
    // write post-action user code here
    }//GEN-BEGIN:|3-startMIDlet|2|
    //</editor-fold>//GEN-END:|3-startMIDlet|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: resumeMIDlet ">//GEN-BEGIN:|4-resumeMIDlet|0|4-preAction
    /**
     * Performs an action assigned to the Mobile Device - MIDlet Resumed point.
     */
    public void resumeMIDlet() {//GEN-END:|4-resumeMIDlet|0|4-preAction
    // write pre-action user code here
//GEN-LINE:|4-resumeMIDlet|1|4-postAction
    // write post-action user code here
    }//GEN-BEGIN:|4-resumeMIDlet|2|
    //</editor-fold>//GEN-END:|4-resumeMIDlet|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: switchDisplayable ">//GEN-BEGIN:|5-switchDisplayable|0|5-preSwitch
    /**
     * Switches a current displayable in a display. The <code>display</code> instance is taken from <code>getDisplay</code> method. This method is used by all actions in the design for switching displayable.
     * @param alert the Alert which is temporarily set to the display; if <code>null</code>, then <code>nextDisplayable</code> is set immediately
     * @param nextDisplayable the Displayable to be set
     */
    public void switchDisplayable(Alert alert, Displayable nextDisplayable) {//GEN-END:|5-switchDisplayable|0|5-preSwitch
        // write pre-switch user code here
        Display display = getDisplay();//GEN-BEGIN:|5-switchDisplayable|1|5-postSwitch
        if (alert == null) {
            display.setCurrent(nextDisplayable);
        } else {
            display.setCurrent(alert, nextDisplayable);
        }//GEN-END:|5-switchDisplayable|1|5-postSwitch
    // write post-switch user code here
    }//GEN-BEGIN:|5-switchDisplayable|2|
    //</editor-fold>//GEN-END:|5-switchDisplayable|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: commandAction for Displayables ">//GEN-BEGIN:|7-commandAction|0|7-preCommandAction
    /**
     * Called by a system to indicated that a command has been invoked on a particular displayable.
     * @param command the Command that was invoked
     * @param displayable the Displayable where the command was invoked
     */
    public void commandAction(Command command, Displayable displayable) {//GEN-END:|7-commandAction|0|7-preCommandAction
        // write pre-action user code here
        if (displayable == aboutText) {//GEN-BEGIN:|7-commandAction|1|67-preAction
            if (command == okCommand) {//GEN-END:|7-commandAction|1|67-preAction
                // write pre-action user code here
                switchDisplayable(null, getMenuForm());//GEN-LINE:|7-commandAction|2|67-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|3|30-preAction
        } else if (displayable == frmWaiting) {
            if (command == cancelCommand) {//GEN-END:|7-commandAction|3|30-preAction
                // write pre-action user code here
                switchDisplayable(null, getLstRole());//GEN-LINE:|7-commandAction|4|30-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|5|69-preAction
        } else if (displayable == instructionText) {
            if (command == okCommand1) {//GEN-END:|7-commandAction|5|69-preAction
                // write pre-action user code here
                switchDisplayable(null, getMenuForm());//GEN-LINE:|7-commandAction|6|69-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|7|19-preAction
        } else if (displayable == lstRole) {
            if (command == List.SELECT_COMMAND) {//GEN-END:|7-commandAction|7|19-preAction
                // write pre-action user code here
                lstRoleAction();//GEN-LINE:|7-commandAction|8|19-postAction
            // write post-action user code here
            } else if (command == exitCommand) {//GEN-LINE:|7-commandAction|9|33-preAction
                // write pre-action user code here
                exitMIDlet();//GEN-LINE:|7-commandAction|10|33-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|11|59-preAction
        } else if (displayable == menuForm) {
            if (command == aboutCommand) {//GEN-END:|7-commandAction|11|59-preAction
                // write pre-action user code here
                switchDisplayable(null, getAboutText());//GEN-LINE:|7-commandAction|12|59-postAction
            // write post-action user code here
            } else if (command == exitCommand4) {//GEN-LINE:|7-commandAction|13|55-preAction
                // write pre-action user code here
                exitMIDlet();//GEN-LINE:|7-commandAction|14|55-postAction
            // write post-action user code here
            } else if (command == instructionCommand) {//GEN-LINE:|7-commandAction|15|61-preAction
                // write pre-action user code here
                switchDisplayable(null, getInstructionText());//GEN-LINE:|7-commandAction|16|61-postAction
            // write post-action user code here
            } else if (command == newCommand1) {//GEN-LINE:|7-commandAction|17|57-preAction
                // write pre-action user code here
                switchDisplayable(null, getLstRole());//GEN-LINE:|7-commandAction|18|57-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|19|36-preAction
        } else if (displayable == txtConnection) {
            if (command == exitCommand1) {//GEN-END:|7-commandAction|19|36-preAction
                // write pre-action user code here
                exitMIDlet();//GEN-LINE:|7-commandAction|20|36-postAction
            // write post-action user code here
            } else if (command == gameCommand) {//GEN-LINE:|7-commandAction|21|40-preAction
                // write pre-action user code here
                CommonVariables.engine.init();
                switchDisplayable(null, getGameCanvas());
//GEN-LINE:|7-commandAction|22|40-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|23|7-postCommandAction
        }//GEN-END:|7-commandAction|23|7-postCommandAction
else if (displayable == gameCanvas) {
            if (command == exitCommand3) {
                exitMIDlet();
            } else if (command == newCommand) {
                // write game initiation proc
                CommonVariables.engine.init();
                ((Canvas) gameCanvas).repaint();
                CommonVariables.myTurn = true;
                ReadWrite.write("new");
            }
        }
    }//GEN-BEGIN:|7-commandAction|24|
    //</editor-fold>//GEN-END:|7-commandAction|24|
    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: lstRole ">//GEN-BEGIN:|17-getter|0|17-preInit
    /**
     * Returns an initiliazed instance of lstRole component.
     * @return the initialized component instance
     */
    public List getLstRole() {
        if (lstRole == null) {//GEN-END:|17-getter|0|17-preInit
            // write pre-init user code here
            lstRole = new List("Connection Manager", Choice.IMPLICIT);//GEN-BEGIN:|17-getter|1|17-postInit
            lstRole.append("Wait for a connection", null);
            lstRole.append("Connect to a server", null);
            lstRole.addCommand(getExitCommand());
            lstRole.setCommandListener(this);
            lstRole.setSelectedFlags(new boolean[] { false, false });//GEN-END:|17-getter|1|17-postInit
        // write post-init user code here
        }//GEN-BEGIN:|17-getter|2|
        return lstRole;
    }
    //</editor-fold>//GEN-END:|17-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: lstRoleAction ">//GEN-BEGIN:|17-action|0|17-preAction
    /**
     * Performs an action assigned to the selected list element in the lstRole component.
     */
    public void lstRoleAction() {//GEN-END:|17-action|0|17-preAction
        // enter pre-action user code here
        String __selectedString = getLstRole().getString(getLstRole().getSelectedIndex());//GEN-BEGIN:|17-action|1|22-preAction
        if (__selectedString != null) {
            if (__selectedString.equals("Wait for a connection")) {//GEN-END:|17-action|1|22-preAction
                // write pre-action user code here
                switchDisplayable(null, getFrmWaiting());//GEN-LINE:|17-action|2|22-postAction
                // write post-action user code here
                new Thread(new BlueServer(this)).start();
            } else if (__selectedString.equals("Connect to a server")) {//GEN-LINE:|17-action|3|23-preAction
                // write pre-action user code here
                switchDisplayable(null, getFrmWaiting());//GEN-LINE:|17-action|4|23-postAction
                // write post-action user code here
                new Thread(new BlueClient(this)).start();
            }//GEN-BEGIN:|17-action|5|17-postAction
        }//GEN-END:|17-action|5|17-postAction
    // enter post-action user code here
    }//GEN-BEGIN:|17-action|6|
    //</editor-fold>//GEN-END:|17-action|6|
    public Displayable getGameCanvas() {
        if (gameCanvas == null) {
            System.out.println("in get game canvas");
            gameCanvas = new BlueCanvas(this);
            gameCanvas.addCommand(getExitCommand3());
            gameCanvas.addCommand(getNewCommand());
            gameCanvas.setCommandListener(this);
        // write post-init user code here
        }

        return gameCanvas;
    }

    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: frmWaiting ">//GEN-BEGIN:|24-getter|0|24-preInit
    /**
     * Returns an initiliazed instance of frmWaiting component.
     * @return the initialized component instance
     */
    public Form getFrmWaiting() {
        if (frmWaiting == null) {//GEN-END:|24-getter|0|24-preInit
            // write pre-init user code here
            frmWaiting = new Form("Connection Manager", new Item[] { getStringItem() });//GEN-BEGIN:|24-getter|1|24-postInit
            frmWaiting.setTicker(getTicker());
            frmWaiting.addCommand(getCancelCommand());
            frmWaiting.setCommandListener(this);//GEN-END:|24-getter|1|24-postInit
        // write post-init user code here
        }//GEN-BEGIN:|24-getter|2|
        return frmWaiting;
    }
    //</editor-fold>//GEN-END:|24-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: txtConnection ">//GEN-BEGIN:|26-getter|0|26-preInit
    /**
     * Returns an initiliazed instance of txtConnection component.
     * @return the initialized component instance
     */
    public TextBox getTxtConnection() {
        if (txtConnection == null) {//GEN-END:|26-getter|0|26-preInit
            // write pre-init user code here
            txtConnection = new TextBox("Device Discovered", null, 100, TextField.ANY);//GEN-BEGIN:|26-getter|1|26-postInit
            txtConnection.addCommand(getExitCommand1());
            txtConnection.addCommand(getGameCommand());
            txtConnection.setCommandListener(this);//GEN-END:|26-getter|1|26-postInit
        // write post-init user code here
        }//GEN-BEGIN:|26-getter|2|
        return txtConnection;
    }
    //</editor-fold>//GEN-END:|26-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: ticker ">//GEN-BEGIN:|25-getter|0|25-preInit
    /**
     * Returns an initiliazed instance of ticker component.
     * @return the initialized component instance
     */
    public Ticker getTicker() {
        if (ticker == null) {//GEN-END:|25-getter|0|25-preInit
            // write pre-init user code here
            ticker = new Ticker("Waiting for connection");//GEN-LINE:|25-getter|1|25-postInit
        // write post-init user code here
        }//GEN-BEGIN:|25-getter|2|
        return ticker;
    }
    //</editor-fold>//GEN-END:|25-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: cancelCommand ">//GEN-BEGIN:|29-getter|0|29-preInit
    /**
     * Returns an initiliazed instance of cancelCommand component.
     * @return the initialized component instance
     */
    public Command getCancelCommand() {
        if (cancelCommand == null) {//GEN-END:|29-getter|0|29-preInit
            // write pre-init user code here
            cancelCommand = new Command("Cancel", Command.CANCEL, 0);//GEN-LINE:|29-getter|1|29-postInit
        // write post-init user code here
        }//GEN-BEGIN:|29-getter|2|
        return cancelCommand;
    }
    //</editor-fold>//GEN-END:|29-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: exitCommand ">//GEN-BEGIN:|32-getter|0|32-preInit
    /**
     * Returns an initiliazed instance of exitCommand component.
     * @return the initialized component instance
     */
    public Command getExitCommand() {
        if (exitCommand == null) {//GEN-END:|32-getter|0|32-preInit
            // write pre-init user code here
            exitCommand = new Command("Exit", Command.EXIT, 0);//GEN-LINE:|32-getter|1|32-postInit
        // write post-init user code here
        }//GEN-BEGIN:|32-getter|2|
        return exitCommand;
    }
    //</editor-fold>//GEN-END:|32-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: exitCommand1 ">//GEN-BEGIN:|35-getter|0|35-preInit
    /**
     * Returns an initiliazed instance of exitCommand1 component.
     * @return the initialized component instance
     */
    public Command getExitCommand1() {
        if (exitCommand1 == null) {//GEN-END:|35-getter|0|35-preInit
            // write pre-init user code here
            exitCommand1 = new Command("Exit", Command.EXIT, 0);//GEN-LINE:|35-getter|1|35-postInit
        // write post-init user code here
        }//GEN-BEGIN:|35-getter|2|
        return exitCommand1;
    }
    //</editor-fold>//GEN-END:|35-getter|2|
    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: gameCommand ">//GEN-BEGIN:|39-getter|0|39-preInit
    /**
     * Returns an initiliazed instance of gameCommand component.
     * @return the initialized component instance
     */
    public Command getGameCommand() {
        if (gameCommand == null) {//GEN-END:|39-getter|0|39-preInit
            // write pre-init user code here
            gameCommand = new Command("Start Game", Command.SCREEN, 0);//GEN-LINE:|39-getter|1|39-postInit
        // write post-init user code here
        }//GEN-BEGIN:|39-getter|2|
        return gameCommand;
    }
    //</editor-fold>//GEN-END:|39-getter|2|
    public Command getExitCommand3() {
        if (exitCommand3 == null) {
            // write pre-init user code here
            exitCommand3 = new Command("Exit", Command.EXIT, 0);
        // write post-init user code here
        }
        return exitCommand3;
    }

    public Command getNewCommand() {
        if (newCommand == null) {
            // write pre-init user code here
            newCommand = new Command("New Game", Command.SCREEN, 0);
        // write post-init user code here
        }
        return newCommand;
    }

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: exitCommand2 ">//GEN-BEGIN:|42-getter|0|42-preInit
    /**
     * Returns an initiliazed instance of exitCommand2 component.
     * @return the initialized component instance
     */
    public Command getExitCommand2() {
        if (exitCommand2 == null) {//GEN-END:|42-getter|0|42-preInit
            // write pre-init user code here
            exitCommand2 = new Command("Exit", Command.EXIT, 0);//GEN-LINE:|42-getter|1|42-postInit
        // write post-init user code here
        }//GEN-BEGIN:|42-getter|2|
        return exitCommand2;
    }
    //</editor-fold>//GEN-END:|42-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: sendCommand ">//GEN-BEGIN:|48-getter|0|48-preInit
    /**
     * Returns an initiliazed instance of sendCommand component.
     * @return the initialized component instance
     */
    public Command getSendCommand() {
        if (sendCommand == null) {//GEN-END:|48-getter|0|48-preInit
            // write pre-init user code here
            sendCommand = new Command("Send", Command.SCREEN, 0);//GEN-LINE:|48-getter|1|48-postInit
        // write post-init user code here
        }//GEN-BEGIN:|48-getter|2|
        return sendCommand;
    }
    //</editor-fold>//GEN-END:|48-getter|2|
    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: turnAlert ">//GEN-BEGIN:|52-getter|0|52-preInit
    /**
     * Returns an initiliazed instance of turnAlert component.
     * @return the initialized component instance
     */
    public Alert getTurnAlert() {
        if (turnAlert == null) {//GEN-END:|52-getter|0|52-preInit
            // write pre-init user code here
            turnAlert = new Alert("Sorry!!", "Its your opposition\'s turn!!", null, AlertType.ERROR);//GEN-BEGIN:|52-getter|1|52-postInit
            turnAlert.setTimeout(Alert.FOREVER);//GEN-END:|52-getter|1|52-postInit
        // write post-init user code here
        }//GEN-BEGIN:|52-getter|2|
        return turnAlert;
    }
    //</editor-fold>//GEN-END:|52-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: menuForm ">//GEN-BEGIN:|53-getter|0|53-preInit
    /**
     * Returns an initiliazed instance of menuForm component.
     * @return the initialized component instance
     */
    public Form getMenuForm() {
        if (menuForm == null) {//GEN-END:|53-getter|0|53-preInit
            // write pre-init user code here
            menuForm = new Form("BlueTTT", new Item[] { getNameImage(), getWelcomeString() });//GEN-BEGIN:|53-getter|1|53-postInit
            menuForm.addCommand(getExitCommand4());
            menuForm.addCommand(getNewCommand1());
            menuForm.addCommand(getAboutCommand());
            menuForm.addCommand(getInstructionCommand());
            menuForm.setCommandListener(this);//GEN-END:|53-getter|1|53-postInit
        // write post-init user code here
        }//GEN-BEGIN:|53-getter|2|
        return menuForm;
    }
    //</editor-fold>//GEN-END:|53-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: instructionText ">//GEN-BEGIN:|64-getter|0|64-preInit
    /**
     * Returns an initiliazed instance of instructionText component.
     * @return the initialized component instance
     */
    public TextBox getInstructionText() {
        if (instructionText == null) {//GEN-END:|64-getter|0|64-preInit
            // write pre-init user code here
            instructionText = new TextBox("Instructions", "To play BlueTTT you need to have BlueTooth in your device. One player will wait for connection and another one will connect. Your target would be to fill up three boxes with your sign either horizontally, diagonally or vertically. Who does this first, wins! Use neumeric keypad (1-9) of your mobile for corresponding box in display.\nHappy playing!!!", 349, TextField.ANY);//GEN-BEGIN:|64-getter|1|64-postInit
            instructionText.addCommand(getOkCommand1());
            instructionText.setCommandListener(this);//GEN-END:|64-getter|1|64-postInit
        // write post-init user code here
        }//GEN-BEGIN:|64-getter|2|
        return instructionText;
    }
    //</editor-fold>//GEN-END:|64-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: aboutText ">//GEN-BEGIN:|65-getter|0|65-preInit
    /**
     * Returns an initiliazed instance of aboutText component.
     * @return the initialized component instance
     */
    public TextBox getAboutText() {
        if (aboutText == null) {//GEN-END:|65-getter|0|65-preInit
            // write pre-init user code here
            aboutText = new TextBox("About BlueTTT", "Welcome to BlueTTT. This is a two player bluetooth based classic Tic Tac Toe game.\n\nDeveloped by:\nSumanta Saha\nMd Sakhawat Hossen\nMd Safiqul Islam\nKTH, Sweden", 158, TextField.ANY);//GEN-BEGIN:|65-getter|1|65-postInit
            aboutText.addCommand(getOkCommand());
            aboutText.setCommandListener(this);//GEN-END:|65-getter|1|65-postInit
        // write post-init user code here
        }//GEN-BEGIN:|65-getter|2|
        return aboutText;
    }
    //</editor-fold>//GEN-END:|65-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: exitCommand4 ">//GEN-BEGIN:|54-getter|0|54-preInit
    /**
     * Returns an initiliazed instance of exitCommand4 component.
     * @return the initialized component instance
     */
    public Command getExitCommand4() {
        if (exitCommand4 == null) {//GEN-END:|54-getter|0|54-preInit
            // write pre-init user code here
            exitCommand4 = new Command("Exit", Command.EXIT, 0);//GEN-LINE:|54-getter|1|54-postInit
        // write post-init user code here
        }//GEN-BEGIN:|54-getter|2|
        return exitCommand4;
    }
    //</editor-fold>//GEN-END:|54-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: newCommand1 ">//GEN-BEGIN:|56-getter|0|56-preInit
    /**
     * Returns an initiliazed instance of newCommand1 component.
     * @return the initialized component instance
     */
    public Command getNewCommand1() {
        if (newCommand1 == null) {//GEN-END:|56-getter|0|56-preInit
            // write pre-init user code here
            newCommand1 = new Command("New Game", Command.SCREEN, 0);//GEN-LINE:|56-getter|1|56-postInit
        // write post-init user code here
        }//GEN-BEGIN:|56-getter|2|
        return newCommand1;
    }
    //</editor-fold>//GEN-END:|56-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: aboutCommand ">//GEN-BEGIN:|58-getter|0|58-preInit
    /**
     * Returns an initiliazed instance of aboutCommand component.
     * @return the initialized component instance
     */
    public Command getAboutCommand() {
        if (aboutCommand == null) {//GEN-END:|58-getter|0|58-preInit
            // write pre-init user code here
            aboutCommand = new Command("About BlueTTT", Command.SCREEN, 0);//GEN-LINE:|58-getter|1|58-postInit
        // write post-init user code here
        }//GEN-BEGIN:|58-getter|2|
        return aboutCommand;
    }
    //</editor-fold>//GEN-END:|58-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: instructionCommand ">//GEN-BEGIN:|60-getter|0|60-preInit
    /**
     * Returns an initiliazed instance of instructionCommand component.
     * @return the initialized component instance
     */
    public Command getInstructionCommand() {
        if (instructionCommand == null) {//GEN-END:|60-getter|0|60-preInit
            // write pre-init user code here
            instructionCommand = new Command("Instructions", Command.SCREEN, 0);//GEN-LINE:|60-getter|1|60-postInit
        // write post-init user code here
        }//GEN-BEGIN:|60-getter|2|
        return instructionCommand;
    }
    //</editor-fold>//GEN-END:|60-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: okCommand ">//GEN-BEGIN:|66-getter|0|66-preInit
    /**
     * Returns an initiliazed instance of okCommand component.
     * @return the initialized component instance
     */
    public Command getOkCommand() {
        if (okCommand == null) {//GEN-END:|66-getter|0|66-preInit
            // write pre-init user code here
            okCommand = new Command("Ok", Command.OK, 0);//GEN-LINE:|66-getter|1|66-postInit
        // write post-init user code here
        }//GEN-BEGIN:|66-getter|2|
        return okCommand;
    }
    //</editor-fold>//GEN-END:|66-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: okCommand1 ">//GEN-BEGIN:|68-getter|0|68-preInit
    /**
     * Returns an initiliazed instance of okCommand1 component.
     * @return the initialized component instance
     */
    public Command getOkCommand1() {
        if (okCommand1 == null) {//GEN-END:|68-getter|0|68-preInit
            // write pre-init user code here
            okCommand1 = new Command("Ok", Command.OK, 0);//GEN-LINE:|68-getter|1|68-postInit
        // write post-init user code here
        }//GEN-BEGIN:|68-getter|2|
        return okCommand1;
    }
    //</editor-fold>//GEN-END:|68-getter|2|
    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: image ">//GEN-BEGIN:|76-getter|0|76-preInit
    /**
     * Returns an initiliazed instance of image component.
     * @return the initialized component instance
     */
    public Image getImage() {
        if (image == null) {//GEN-END:|76-getter|0|76-preInit
            // write pre-init user code here
            try {//GEN-BEGIN:|76-getter|1|76-@java.io.IOException
                image = Image.createImage("/name.png");
            } catch (java.io.IOException e) {//GEN-END:|76-getter|1|76-@java.io.IOException
                e.printStackTrace();
            }//GEN-LINE:|76-getter|2|76-postInit
        // write post-init user code here
        }//GEN-BEGIN:|76-getter|3|
        return image;
    }
    //</editor-fold>//GEN-END:|76-getter|3|
    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: welcomeString ">//GEN-BEGIN:|78-getter|0|78-preInit
    /**
     * Returns an initiliazed instance of welcomeString component.
     * @return the initialized component instance
     */
    public StringItem getWelcomeString() {
        if (welcomeString == null) {//GEN-END:|78-getter|0|78-preInit
            // write pre-init user code here
            welcomeString = new StringItem("Welcome to BlueTTT", "\nDeveloped by\nSumanta Saha\nMd Sakhawat Hossen\nMd Safiqul Islam");//GEN-LINE:|78-getter|1|78-postInit
        // write post-init user code here
        }//GEN-BEGIN:|78-getter|2|
        return welcomeString;
    }
    //</editor-fold>//GEN-END:|78-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: nameImage ">//GEN-BEGIN:|80-getter|0|80-preInit
    /**
     * Returns an initiliazed instance of nameImage component.
     * @return the initialized component instance
     */
    public ImageItem getNameImage() {
        if (nameImage == null) {//GEN-END:|80-getter|0|80-preInit
            // write pre-init user code here
            nameImage = new ImageItem("", getImage(), ImageItem.LAYOUT_DEFAULT, "BlueTTT");//GEN-LINE:|80-getter|1|80-postInit
        // write post-init user code here
        }//GEN-BEGIN:|80-getter|2|
        return nameImage;
    }
    //</editor-fold>//GEN-END:|80-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: stringItem ">//GEN-BEGIN:|81-getter|0|81-preInit
    /**
     * Returns an initiliazed instance of stringItem component.
     * @return the initialized component instance
     */
    public StringItem getStringItem() {
        if (stringItem == null) {//GEN-END:|81-getter|0|81-preInit
            // write pre-init user code here
            stringItem = new StringItem("Please wait!!", "While we try to discover a peer for the game...");//GEN-LINE:|81-getter|1|81-postInit
        // write post-init user code here
        }//GEN-BEGIN:|81-getter|2|
        return stringItem;
    }
    //</editor-fold>//GEN-END:|81-getter|2|
    /**
     * Returns a display instance.
     * @return the display instance.
     */
    public Display getDisplay() {
        return Display.getDisplay(this);
    }

    /**
     * Exits MIDlet.
     */
    public void exitMIDlet() {
        switchDisplayable(null, null);
        destroyApp(true);
        notifyDestroyed();
    }

    /**
     * Called when MIDlet is started.
     * Checks whether the MIDlet have been already started and initialize/starts or resumes the MIDlet.
     */
    public void startApp() {

        //MIDP2.0 for push registry
        String connections[];
        //here the argument true means we will only list the connections with input available
        connections = PushRegistry.listConnections(true);

        if (connections == null || connections.length == 0) {
            //midlet started by user not a connection, so start game
            if (midletPaused) {
                resumeMIDlet();
            } else {
                switchDisplayable(null, new BlueSplash(this));
            }
            midletPaused = false;
        } else { //started by push. So start update method

            try {
                incomingConnection = (MessageConnection) Connector.open("sms://:" + incomingPort);
                System.out.println("incoming comm: " + incomingConnection);
                incomingMessage = incomingConnection.receive();

                if (incomingMessage != null && incomingMessage instanceof TextMessage) {
                    Alert alertIncomingMessage = new Alert("");
//                System.out.println("receivied mes from: "+ incomingMessage.getAddress());
//                System.out.println("and payload "+((TextMessage) incomingMessage).getPayloadText());
                    alertIncomingMessage.setTitle("Update message from: " + incomingMessage.getAddress());
                    alertIncomingMessage.setString(((TextMessage) incomingMessage).getPayloadText());
                    alertIncomingMessage.setTimeout(Alert.FOREVER);
                    this.getDisplay().setCurrent(alertIncomingMessage);
                    platformRequest(((TextMessage) incomingMessage).getPayloadText());
                    destroyApp(true);
                    notifyDestroyed();
                }
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                destroyApp(true);
                    notifyDestroyed();
                
            } catch (NullPointerException npe) {
                npe.printStackTrace();
                System.out.println(npe.toString());
                destroyApp(true);
                notifyDestroyed();
            }

        }
    }

    public void splashScreenDone() {
        initialize();
        startMIDlet();
    }

    /**
     * Called when MIDlet is paused.
     */
    public void pauseApp() {
        midletPaused = true;
    }

    /**
     * Called to signal the MIDlet to terminate.
     * @param unconditional if true, then the MIDlet has to be unconditionally terminated and all resources has to be released.
     */
    public void destroyApp(boolean unconditional) {
        try {
            if (CommonVariables.conn != null) {
                CommonVariables.conn.close();
            }
            if(CommonVariables.audio != null) {
                CommonVariables.audio.stop();
                CommonVariables.audio.close();
            }
            CommonVariables.engine = null;
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
